"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.parsers = exports.parserKeys = void 0;
const debug_1 = __importDefault(require("debug"));
const feedme_1 = require("./feedme");
const rss_parser_1 = require("./rss-parser");
const feedparser_1 = require("./feedparser");
const rss_to_json_1 = require("./rss-to-json");
const jsonfeed_v1_1 = require("./jsonfeed-v1");
const debug = (0, debug_1.default)('graphql-rss-parser:parsers');
exports.parserKeys = [
    'FEEDPARSER',
    'RSS_PARSER',
    'FEEDME',
    'RSS_TO_JSON',
];
debug('active parsers:', exports.parserKeys);
exports.parsers = {
    RSS_PARSER: rss_parser_1.parse,
    FEEDPARSER: feedparser_1.parse,
    FEEDME: feedme_1.parse,
    RSS_TO_JSON: rss_to_json_1.parse,
    JSON_FEED_V1: jsonfeed_v1_1.parse,
};
//# sourceMappingURL=index.js.map