"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.parse = void 0;
const debug_1 = __importDefault(require("debug"));
const debug = (0, debug_1.default)('graphql-rss-parser:parsers:json-parser');
async function parse(input) {
    const content = JSON.parse(input);
    debug('starting to transform');
    let authors;
    if (content.version === 'https://jsonfeed.org/version/1') {
        authors = content.author ? [content.author] : [];
    }
    else {
        authors = content.authors;
    }
    const output = {
        parser: 'JSON_FEED_V1',
        title: content.title,
        feed_url: content.feed_url,
        home_page_url: content.home_page_url,
        authors,
        description: content.description,
        items: content.items?.map((item) => {
            if (content.version === 'https://jsonfeed.org/version/1') {
                const author = item.author;
                delete item.author;
                return { ...item, authors: author ? [author] : [] };
            }
            else {
                return item;
            }
        }) || [],
    };
    debug('done transform');
    return output;
}
exports.parse = parse;
//# sourceMappingURL=jsonfeed-v1.js.map