"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.schema = void 0;
const graphql_tools_1 = require("graphql-tools");
const debug_1 = __importDefault(require("debug"));
const feed = __importStar(require("./handlers/feed"));
const findFeed_1 = require("./handlers/findFeed");
const debug = (0, debug_1.default)('graphql-rss-parser:schema');
const typeDefs = `
  enum Parser {
    FEEDPARSER
    RSS_PARSER
    FEEDME
    RSS_TO_JSON
    JSON_FEED_V1
  }

  type FindFeedResult {
    title: String
    link: String!
  }

  type FeedItem {
    id: String
    title: String
    url: String
    date_published: String
    guid: String
    author: String
    tags: [String!]!
  }

  type Feed {
    version: String
    title: String
    feed_url: String
    home_page_url: String
    parser: Parser
    author: String
    guid: String
    items: [FeedItem!]!
  }

  type Query {
    findFeed(url: String!): [FindFeedResult]!
    feed(url: String!, parser: Parser, startTime: String, endTime: String): Feed
  }
`;
const resolvers = {
    Query: {
        feed: (_, query) => {
            debug('query-resolver feed, query:', query);
            return feed.parseFromQuery(query);
        },
        findFeed: (_, query) => {
            debug('query-resolver findFeed, query:', query);
            return (0, findFeed_1.findFeed)(query);
        },
    },
};
exports.schema = (0, graphql_tools_1.makeExecutableSchema)({
    typeDefs,
    resolvers,
});
//# sourceMappingURL=schema.js.map